const { loadStates } = require("../data/states.js");
const { loadCandidates } = require("../data/candidates.js");

const fields = [
  {
    id: "description",
    type: "longtext",
    required: true,
    for: "submitter",
    displayName: "What did you see or hear?",
    hint: "Describe it",
  },
  {
    id: "disinfo_links",
    type: "stringlist",
    for: "submitter",
    default: [],
    hint: "Paste Link",
  },
  {
    id: "attachments",
    type: "objectlist",
    for: "submitter",
    hint: "Add Files",
    default: [],
    keys: [
      { id: "filename", type: "text" },
      { id: "mimetype", type: "text" },
      {
        id: "payload",
        type: "text",
        comment: "The base64 contents of the attachment",
      },
    ],
  },
  {
    id: "sighted_on",
    type: "date",
    for: "submitter",
    displayName: "When did it happen?",
    default: "",
    hint: "Date",
  },
  {
    id: "geography",
    displayName: "Where were you when it happened?",
    hint: "State",
    type: "select",
    options: loadStates(),
    for: "submitter",
  },
  {
    id: "reason",
    type: "longtext",
    for: "submitter",
    displayName: "What's suspicious about it?",
    default: "",
    hint: "Explain",
  },
  {
    id: "medium",
    type: "multiselect",
    for: "submitter",
    displayName: "How did you come across it?",
    caption: "Check all that apply.",
    default: [],
    options: [
      {
        id: "social-media-first-hand",
        name: "In my own social media feed from a person or account I follow",
      },
      {
        id: "social-media-second-hand",
        name: "Someone sent it to me on social media",
      },
      {
        id: "messaging",
        name:
          "Someone sent it to me via text or another messaging app like WhatsApp or WeChat",
      },
      { id: "email", name: "Checking my email" },
      {
        id: "political-activity",
        name:
          "Heard it while engaging in a political activity (organizing, door-knocking, volunteering, community organizing)",
      },
      {
        id: "event",
        name: "At a community event (church, school events, fairs)",
      },
      { id: "online-news", name: "Checking news online" },
      { id: "video-news", name: "Watching the news" },
      { id: "audio-news", name: "Listening to the news" },
      { id: "commute", name: "On my commute" },
    ],
  },
  { id: "medium_other", type: "text", for: "submitter", default: "" },
  {
    id: "additional_info",
    type: "longtext",
    for: "submitter",
    displayName: "Do you have advanced information?",
    default: "",
    caption:
      "For example: Social media account ID numbers or anything else to add.",
    hint: "Please share",
  },
  {
    id: "follow_up",
    type: "select",
    for: "submitter",
    displayName: "Would you like someone to follow up with you?",
    options: [
      { id: "urgent", name: "Yes, need immediate follow up" },
      { id: "not-urgent", name: "Yes, but not urgent" },
      { id: "none", name: "None needed" },
    ],
  },
  {
    id: "submitter_email",
    type: "text",
    hidden: true,
    for: "submitter",
    required: true,
    comment:
      "This field is automatically supplied and is not selectable by the user",
  },
  // here starts analyst fields
  {
    id: "sensitive",
    name: "Sensitive",
    type: "select",
    for: "analyst",
    options: [
      { id: "sensitive", name: "Yes" },
      { id: "not-sensitive", name: "No" },
    ],
  },
  {
    id: "tactic",
    type: "multiselect",
    for: "analyst",
    options: [
      { id: "disinformation", name: "Disinformation" },
      { id: "inauthentic-identity", name: "Inauthentic identity" },
      { id: "false-association", name: "False association" },
      { id: "automated-account", name: "Automated account" },
      { id: "harassment", name: "Harassment" },
      { id: "hate-speech", name: "Hate speech" },
      { id: "defamation", name: "Defamation " },
      { id: "doxxing", name: "Doxxing" },
      { id: "voter-suppression", name: "Voter suppression" },
      { id: "trademark-violation", name: "Trademark violation" },
      { id: "manipulated-media", name: "Manipulated media" },
      { id: "impersonation", name: "impersonation" },
    ],
  },
  {
    id: "platform",
    type: "multiselect",
    for: "analyst",
    options: [
      { id: "twitter-account", name: "Twitter: account" },
      { id: "twitter-ads", name: "Twitter: ads" },
      { id: "twitter-other", name: "Twitter: other" },
      { id: "facebook-ads", name: "Facebook: ads" },
      { id: "facebook-group", name: "Facebook: group" },
      { id: "facebook-page", name: "Facebook: page" },
      { id: "facebook-account", name: "Facebook: account" },
      { id: "facebook-other", name: "Facebook: other" },
      { id: "youtube-channel", name: "YouTube: channel" },
      { id: "youtube-video", name: "YouTube: video" },
      { id: "youtube-account", name: "YouTube: account" },
      { id: "youtube-other", name: "YouTube: other" },
      { id: "whatsapp-group", name: "Whatsapp: group" },
      { id: "whatsapp-other", name: "Whatsapp: other" },
      { id: "instagram-account", name: "Instagram: account" },
      { id: "instagram-ads", name: "Instagram: ads" },
      { id: "instagram-other", name: "Instagram: other" },
      { id: "google-search-result", name: "Google Search result" },
      { id: "google-onedrive", name: "Google OneDrive" },
      { id: "telegram-channel", name: "Telegram: channel" },
      { id: "telegram-account", name: "Telegram: account" },
      { id: "telegram-other", name: "Telegram: other" },
      { id: "pinterest", name: "Pinterest" },
      { id: "tumblr", name: "Tumblr" },
      { id: "reddit", name: "Reddit" },
      { id: "4chan", name: "4Chan" },
      { id: "8chan", name: "8Chan" },
      { id: "discord-server", name: "Discord: server" },
      { id: "discord-other", name: "Discord: other" },
      { id: "gab-channel", name: "Gab: channel" },
      { id: "gab-account", name: "Gab: account" },
      { id: "gab-other", name: "Gab: other" },
      { id: "email", name: "Email" },
      { id: "snapchat-account", name: "Snapchat: account" },
      { id: "snapchat-ads", name: "Snapchat: ads" },
      { id: "snapchat-other", name: "Snapchat: other" },
      { id: "tiktok", name: "TikTok" },
      { id: "kik", name: "Kik" },
      { id: "wechat", name: "WeChat" },
      { id: "skype", name: "Skype" },
      { id: "viber", name: "Viber" },
      { id: "linkedin", name: "LinkedIn" },
      { id: "vkontakte-group", name: "VKontakte: group" },
      { id: "vkontakte-account", name: "VKontakte: account" },
      { id: "vkontakte-other", name: "VKontakte: other" },
      { id: "qq", name: "QQ " },
    ],
  },
  {
    id: "party",
    name: "Political Party",
    type: "multiselect",
    for: "analyst",
    options: [
      { id: "RNC", name: "Republican Party" },
      { id: "DNC", name: "Democratic Party" },
      { id: "CP", name: "Constitution Party" },
      { id: "GP", name: "Green Party" },
      { id: "LP", name: "Libertarian Party" },
      { id: "unaffiliated", name: "Unaffiliated" },
    ],
  },
  {
    id: "candidate",
    type: "multiselect",
    for: "analyst",
    options: [
      { id: "klobuchar", name: "Amy Klobuchar" },
      { id: "sanders", name: "Bernie Sanders" },
      { id: "weld", name: "Bill Weld" },
      { id: "trump", name: "Donald J. Trump" },
      { id: "warren", name: "Elizabeth Warren" },
      { id: "biden", name: "Joe Biden" },
      { id: "bloomberg", name: "Michael Bloomberg" },
      { id: "buttigieg", name: "Pete Buttigieg" },
      { id: "fuente", name: "Roque De La Fuente" },
      { id: "steyer", name: "Tom Steyer" },
      { id: "gabbard", name: "Tulsi Gabbard" },
    ],
  },
  {
    id: "candidate_race",
    type: "treeselect",
    for: "analyst",
    options: loadCandidates(),
  },
  {
    id: "actor",
    type: "multiselect",
    for: "analyst",
    default: "unknown",
    options: [
      { id: "foreign-state", name: "Foreign state source" },
      { id: "political-party", name: "Political party" },
      { id: "political-candidate", name: "Political candidate" },
      { id: "campaign-group", name: "Campaign group" },
      { id: "domestic-hate-group", name: "Domestic hate group" },
      { id: "foreign-hate-group", name: "Foreign/global hate group" },
      { id: "unknown", name: "Unknown" },
    ],
  },
  {
    id: "communities",
    name: "Target Community",
    type: "multiselect",
    for: "analyst",
    options: [
      { id: "black", name: "Black community" },
      { id: "jewish", name: "Jewish community" },
      { id: "muslim", name: "Muslim community" },
      { id: "hindu", name: "Hindu community" },
      { id: "sikh", name: "Sikh community" },
      { id: "latino-hispanic", name: "Latino or Hispanic community" },
      { id: "american-indian", name: "American Indian community" },
      { id: "asian-american", name: "Asian American community" },
      { id: "lgbtq", name: "LGBTQ community" },
    ],
  },

  // metadata fields
  {
    id: "comments",
    name: "Analyst Comments",
    type: "objectlist",
    for: "analyst",
    keys: [
      { id: "comment", type: "longtext" },
      { id: "author", type: "text" },
      { id: "commented_at", type: "timestamp" },
    ],
  },
];
module.exports.FieldsV1 = fields;
